\# $Id: pthread_attr_init.man,v 1.1.1.1 1996/06/29 01:20:50 mtp Exp $
\#---------------------------------------------------------------------------
\#    
\#  COPYRIGHT NOTICE
\#    
\#  Copyright (C) 1995, 1996 Michael T. Peterson
\#  This file is part of the PCthreads (tm) multithreading library
\#  package.
\#    
\#  The source files and libraries constituting the PCthreads (tm) package
\#  are free software; you can redistribute them and/or modify them under
\#  the terms of the GNU Library General Public License as published by the Free
\#  Software Foundation; either version 2 of the License, or (at your
\#  option) any later version.
\#    
\#  The PCthreads (tm) package is distributed in the hope that it will
\#  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
\#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
\#  Library General Public License for more details.
\#    
\#  You should have received a copy of the GNU Library General Public
\#  License along with this library (see the file COPYING.LIB); if not,
\#  write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
\#  MA 02139, USA.
\#    
\#  To report bugs, bug fixes, or provide feedback you may contact the
\#  author, Michael T. Peterson, at either of the two email addresses listed
\#  below:
\#    
\#             mtp@big.aa.net (preferred)
\#             mtp@zso.dec.com
\#    
\#    
\#  Michael T. Peterson
\#  Redmond, WA.
\#  13 January, 1996
\#---------------------------------------------------------------------------
\# $Log: pthread_attr_init.man,v $
\# Revision 1.1.1.1  1996/06/29 01:20:50  mtp
\# pthreads 1.0 distribution
\#
\# Revision 1.1.1.1  1996/06/28 15:45:40  mtp
\# Official V1.0 Sources
\#
\# Revision 2.0  1996/06/28 14:57:47  mtp
\# + Release 2.0
\#
\# Revision 1.3  1996/01/14 20:22:23  mtp
\# + Modified copyright and permission notice to conform with GNU requirements.
\#
\# Revision 1.2  1996/01/14 18:32:04  mtp
\# + Replaced @Header@ with COPYRIGHT NOTICE.
\#
\# Revision 1.1.1.1  1995/12/16 21:41:59  mtp
\# Placed under CVS control
\#
\#---------------------------------------------------------------------------
.TH PCTHREADS 3 "July, 1995" PCTHREADS "POSIX Threads V1.0 For Linux"
.SH NAME
pthread_attr_init \- Initialize a thread attributes object
.br
pthread_attr_destroy \- Delete a thread attributes object 
.SH SYNOPSIS
.B #include <pthread.h>
.sp
.B int
.br
.BI "pthread_attr_init( pthread_t *" attr )
.sp
.B int
.br
.B pthread_attr_destroy( pthread_t *attr )
.SH DESCRIPTION
The
.B pthread_attr_init()
function initializes a thread attributes object.  Thread attributes objects 
are used in calls to
.B pthread_create()
to determine the values of the new thread's attributes.  For each thread
attribute a corresponding set\-get function pair exists. The set of attribute
function pairs supported under PCthreads are listed below:
.sp
.RS
.BI 
pthread_attr_{set,get}detachstate()
.BI 
pthread_attr_{set,get}inheritesched()
.BI
pthread_attr_{set,get}schedparam()
.BI 
pthread_attr_{set,get}schedpolicy()
.BI 
pthread_attr_{set,get}stacksize()
.BI 
pthread_attr_{set,get}quantum_np()
.RE
.PP
See the
.B pthread_create()
or the individual manual pages for the description of each of these attributes.
.PP
The 
.B pthread_attr_destroy()
function deletes the thread attributes object and should be used when the
attributes object is no longer necessary.
.SH PARAMETERS
.SS Input Parameters
.IP attr
The address of memory into which the
.B pthread_attr_init()
function will store the identifier of the new attributes object.  For
.B pthread_attr_destroy()
this parameter is the address of the identifer of the thread attributes object.
.SS Return Parameters
.IP None
.SH RETURN VALUE
A value of zero (0) is returned if no errors are encountered.
When an error condition arises, this routine returns an integer value 
indicating the reason for the error.  Possible error values are:
.TP
.IP EINVAL
The value specified by
.B thread
is NULL.
.IP ENOMEM
The process's heap has become exhausted.
.TP
.SH USAGE EXAMPLE
.PP
See the manual page for the
.B pthread_create()
function.  An example of how to create an attributes object with a 4096 byte
stack is given.
.SH CONFORMING TO
POSIX .1c
.SH SEE ALSO
.B pthread_create(3), pthread_attr_getnnnn(3), pthread_attr_setnnnn(3)
.SH AUTHOR
Michael T. Peterson <mtp@zso.dec. mtp@big.aa.net>







