\#    
\#  COPYRIGHT NOTICE
\#    
\#  Copyright (C) 1995, 1996 Michael T. Peterson
\#  This file is part of the PCthreads (tm) multithreading library
\#  package.
\#    
\#  The source files and libraries constituting the PCthreads (tm) package
\#  are free software; you can redistribute them and/or modify them under
\#  the terms of the GNU Library General Public License as published by the Free
\#  Software Foundation; either version 2 of the License, or (at your
\#  option) any later version.
\#    
\#  The PCthreads (tm) package is distributed in the hope that it will
\#  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
\#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
\#  Library General Public License for more details.
\#    
\#  You should have received a copy of the GNU Library General Public
\#  License along with this library (see the file COPYING.LIB); if not,
\#  write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
\#  MA 02139, USA.
\#    
\#  To report bugs, bug fixes, or provide feedback you may contact the
\#  author, Michael T. Peterson, at either of the two email addresses listed
\#  below:
\#    
\#             mtp@big.aa.net (preferred)
\#             mtp@zso.dec.com
\#    
\#    
\#  Michael T. Peterson
\#  Redmond, WA.
\#  13 January, 1996
.SH NAME
pthread_condattr_init \- Initializes an attributes object.
.br
pthread_condattr_destroy \- Deletes an attributes object.
.br
.SH SYNOPSIS
.B #include <pthread.h>
.sp
.B int
.br
.BI "pthread_condattr_init(pthread_condattr_t *" attr )
.sp
.B int
.br
.BI "pthread_attr_destroy(pthread_condattr_t *" attr )
.SH DESCRIPTION
The
.B pthread_condattr_init()
function initializes the values of a condition variable attributes object to the
library's default values.  Condition variable attributes objects specify 
attribute
values of
condition variables (see the man page for the
.B pthread_cond_init()
function).  Currently, Version 1.0 of PCthreads supports no attributes
except for those supplied by the system as defaults.
.PP
The
.B pthread_condattr_destroy()
function deletes a valid attributes object and returns its resources to
the system.
.SH PARAMETERS
.SS Input Parameters
.IP attr
The address of memory into which the
.B pthread_condattr_init()
function will store the identifier of the new attributes object.  For
.B pthread_condattr_destroy()
this parameter is the address of the identifer of the thread attributes object.
.SS Return Parameters
.IP None
.SH RETURN VALUE
A value of zero (0) is returned if no errors are encountered.
When an error condition arises, this routine returns an integer value 
indicating the reason for the error.  Possible error values are:
.TP
.IP EINVAL
The value specified by
.I attr
is NULL.
.IP ENOMEM
The process's heap has become exhausted.
.TP
.SH USAGE EXAMPLE
.PP
None
.SH CONFORMING TO
POSIX .1c
.SH SEE ALSO
.B pthread_attr_init(3), pthread_attr_destroy(3)
.SH AUTHOR
Michael T. Peterson <mtp@zso.dec. mtp@big.aa.net>
