\# $Id: pthread_info.man,v 1.1.1.1 1996/06/29 01:20:50 mtp Exp $
\#---------------------------------------------------------------------------
\#    
\#  COPYRIGHT NOTICE
\#    
\#  Copyright (C) 1995, 1996 Michael T. Peterson
\#  This file is part of the PCthreads (tm) multithreading library
\#  package.
\#    
\#  The source files and libraries constituting the PCthreads (tm) package
\#  are free software; you can redistribute them and/or modify them under
\#  the terms of the GNU Library General Public License as published by the Free
\#  Software Foundation; either version 2 of the License, or (at your
\#  option) any later version.
\#    
\#  The PCthreads (tm) package is distributed in the hope that it will
\#  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
\#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
\#  Library General Public License for more details.
\#    
\#  You should have received a copy of the GNU Library General Public
\#  License along with this library (see the file COPYING.LIB); if not,
\#  write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
\#  MA 02139, USA.
\#    
\#  To report bugs, bug fixes, or provide feedback you may contact the
\#  author, Michael T. Peterson, at either of the two email addresses listed
\#  below:
\#    
\#             mtp@big.aa.net (preferred)
\#             mtp@zso.dec.com
\#    
\#    
\#  Michael T. Peterson
\#  Redmond, WA.
\#  13 January, 1996
\#---------------------------------------------------------------------------
\# $Log: pthread_info.man,v $
\# Revision 1.1.1.1  1996/06/29 01:20:50  mtp
\# pthreads 1.0 distribution
\#
\# Revision 1.1.1.1  1996/06/28 15:45:40  mtp
\# Official V1.0 Sources
\#
\# Revision 2.0  1996/06/28 14:57:50  mtp
\# + Release 2.0
\#
\# Revision 1.3  1996/01/14 20:22:26  mtp
\# + Modified copyright and permission notice to conform with GNU requirements.
\#
\# Revision 1.2  1996/01/14 18:32:06  mtp
\# + Replaced @Header@ with COPYRIGHT NOTICE.
\#
\# Revision 1.1.1.1  1995/12/16 21:41:59  mtp
\# Placed under CVS control
\#
\#---------------------------------------------------------------------------
.TH PCTHREADS 3 "July, 1995" PCTHREADS "POSIX Threads V1.0 For Linux"
.SH NAME
PCthreads \- POSIX .1c threads for Linux
.SH DESCRIPTION
PCthreads is the first beta release of a complete POSIX .1c threads
library for Linux.  PCthreads attempts to conform to the semantics described
in POSIX .1c, draft 10.  As the package moves toward final release, I hope to
bring the PCthreads package into full conformation.
.PP
This release consists of the following components:
.RS
.TP
.B \(bu
.I libpthread.a:
Version 0.6 of PCthreads library
.TP
.B \(bu
.I libpthread_dce.a:
DCE threads for Linux.  This library is a set of wrapper routines built on
top of libpthread.a.  DCE threads conforms to an early draft of the POSIX .1c
standard, draft 4.  Sources for the wrappers are included.
.TP
.B \(bu
.I libpthread-ext.a:
An exception handling package built on top of libpthread_dce.a.  This package
offers TRY, CATCH, CATCH_ALL, FINALLY, and RERAISE semantics.  I highly
recommend using exceptions.
.TP
.B \(bu
.I Headers:
These include the files
.B pthread.h, typedefs.h,
and
.B exc_handling.h.
.TP
.B \(bu
.I Examples:
Included are a number of simple examples illustrating thread creation, joining,
signal handling, thread-blocking I/O, shared and exclusive locking, a recursive
multithreaded grep, and so forth.
.TP
.B \(bu
.I Documentation:
A complete set of manual pages for the library.
.RS
.SH POSIX THREADS AND SIGNALS
The biggest change in the signal specification is the inclusion of threads
in the standard dealing with signals.  Specifically, the POSIX .1c draft
specifies that signal masks are now per-thread and signal actions remain 
process-wide.
.SS Per-thread signal masks
The
.B sigprocmask(3)
function, formerly used to operate on the process's signal mask, is now used 
to examine and modify the calling thread's signal mask.  This release of 
PCthreads provides a replacement drop-in for sigprocmask(), the
.B pthread_sigmask(3)
function.  If backward compatibility is required, use the preprocessor to 
replace all occurrences of sigprocmask() with
.B pthread_sigmask().
The use of pre-POSIX .1c sigprocmask() in a multithreaded application may
have unpredictable consequences.
.SS Per-process signal actions
Signal actions are per-process and shared by all of the process's threads.For
example, if one thread installs a handler for the SIGTERM signal, that handler 
can be executed in any thread that does not have SIGTERM blocked.  This
could have some unexpected consequences.  If thread 1 specifies SIG_IGN for
SIGTERM, and sometime later thread 2 sets it to SIG_DFL, the process will
be terminated upon receipt of a SIGTERM signal.
.PP
A mechanism has been added to permit per-thread handling of signals delivered
to the process asynchronously (e.g., via kill(1) ), the
.B sigwait(3)
service.  See its manual page for more details.
.SS Signals directed at a thread
Signals which are generated by some action attributable to a particular thread,
such as a hardware fault, are delivered to the thread within whose context
the fault occurred.  This just means that the thread that caused the fault
(e.g., a SIGSEGV) is thread to which the signal is delivered.  Any handler
in effect for that signal is executed within the context of that thread.
.PP
Signals directed to a particular thread via
.B pthread_kill()
are delivered to the specified thread.  If the target thread is not currently
active, the signal is added to the target thread's set of pending signals.
When the thread subsequently becomes active, the pending signal will be
delivered.  POSIX allows one or more pending signals to be delivered.  This
release of Linux delivers exactly 1 pending signal.
.PP
If the target thread has the signal blocked, the signal remains pending on
the thread until the thread unblocks delivery of the signal or the action
associated with the signal is set to ignore the signal.
.PP
A signal pending on a thread will
.I not
become pending for or be delivered to another thread.
.SS Signals directed at a Process
Signals that are directed to the process via
.B kill(1)
or by an asynchronous event such as terminal activity are delivered in one
of two ways:
.RS
.TP
.B \(bu
If one or more threads are blocked in
.B sigwait()
on the signal, one of the threads will be unblocked and return from the
.B sigwait()
function (see manual page).
.TP
.B \(bu
If no sigwait threads exist, then the signal is handled in the context of
the active thread at the time of signal delivery.
.SS Non-local jumps
The
.I longjmp(3), siglongjmp(3), setjmp(3),
and
.I sigsetjmp(3)
functions operate as in POSIX.1 provided the jump buffers have been properly
initialized.  One important restriction is that all non-local jumps must
be within the same thread. In multithreaded programs generally, and in 
PCthread-based programs specifically, non-local jumps into contexts saved by 
other threads results in undefined behavior and is, at best, a questionable
practice.
.SS Signal Handling Functions
When PCthreads is initialized, the runtime interposes itself between the 
kernel's signal interface and the application.  Because of this, when a 
signal is delivered to a PCthread-based application, an internal signal 
dispatch routine is entered.  Among its tasks, it redirects the kernel to 
dispatch the application's signal handler, if one has been installed.
Because PCthreads manages the application's interface certain functions
may not be safely used. These are:
.RS
.TP
.B \(bu
.I sigaction(3)
Use pthread_sigaction_np(3), instead.
.TP
.B \(bu
.I sigprocmask(3)
Use pthread_sigmask(3), instead.
.TP
.B \(bu
.I kill(3)
Use pthread_kill(3), instead.
.RS
When writing signal handlers, keep in mind that they will be invoked as
interrupt routines.  Such services should be short and quick and reentrant.
A good practice for signal handler design is to never invoke any service that
could result in an unbounded wait (i.e., locking a mutex, waiting on a 
select() system call, etc.,).
.SH THREAD SCHEDULING
PCthreads V0.6 is built on top of a strict priority-driven model.  Assuming
a single processor (may not be valid for long ???), the active thread is
.BI always
equal to, or higher in priority than any thread on the runtime's ready queue.
Whenever this invariant is false, the runtime switches context to the higher
priority thread.  This invariant is applied no matter what the scheduling
policy in effect for the thread may be.
.PP
The three scheduling policies supported by PCthreads V0.6 are described below:
.SS SCHED_FIFO
Under this policy, once acquired a SCHED_FIFO thread retains the processor 
until it completes, is preempted by a higher priority thread, or voluntarily
relinquishes the processor.
.SS SCHED_RR
Under this policy, threads
.I share
the processor with other threads of equal priority.  SCHED_RR threads may
be assigned a time quantum (In PCthreads 1 quantum is equal to a time-slice,
or about 10 milliseconds).  Once acquired, such threads execute until their
quantum expires.  At quantum expiration if another thread of equal priority
is found on the ready queue, a context switch to the new thread is executed and
the expired thread's quantum is replenished.
.SS SCHED_OTHER
This policy is more appropriately named priority-decay.  This policy is
designed to allow programmers to develop applications that require some
threads to be very high priority.  However, to prevent starvation of lower
priority threads, the priority-decay policy decrements the thread's priority
every time its quantum expires.  If a high-priority, priority-decay thread
"runs away", its priority will decay until it is preempted.  The rate of
decay is controlled by setting the quantum appropriately.
.SH THREAD TIMERS
PCthreads supplies two timer services, the
.B pthread_delay_np(3)
and the
.B pthread_cond_timedwait(3)
functions.  In the former, the calling thread can delay its execution for
a relative amount of time specified by a
.I struct timespec
data structure (see typedefs.h).  The
.B pthread_cond_timedwait(3)
allows the calling thread to wait until
signaled or a timer expires.
.PP
The SIGVTALRM signal is reserved by PCthreads.
.SH LIBRARY INITIALIZATION
The PCthreads library may be dynamically initialized by specifying a set of
system-wide attributes in an initialization file named
.B .pthread_initrc.
The library looks first in the current working directory and then, if the file
is not found, looks in the application's home directory.  If no file is found,
the library uses the system's hardwired defaults.
.PP
The following is an example of a typical initialization file.
.nf
   #   FILE:       $HOME/.pthread_initrc
   #               1 Oct, 1995
   #
   # Set timer interval to generate a clock interrupt every 40 microseconds.
   # The default timer interval is 20000, or 20 microseconds.  The interrupt
   # may be set as low as every 10000 microseconds.
   Timer interval:    40000

   # When no thread can execute, the process is put to sleep for 80000
   # microseconds. The default idle interval is 20000 microseconds.
   Idle interval:     80000

   # Don't let a thread execute for more than 5 timer intervals before
   # checking whether it should be rescheduled.  The default quantum interval
   # is 2
   Sched quantum:     5

   # After every quantum expiration, the thread's priority is decremented.
   # The default sched policy is SCHED_FIFO_C
   Sched policy:      SCHED_PRIORITY_DECAY_C      

   # Cause all new threads to start with an initial priority of 18.  The 
   # default execution priority is 16.
   Thread priority:   18

   # All new threads start with a stack size of 4096 bytes.  The default
   # is 8192.
   Stack size:        4096
.fi
If any of parameters are left out (or commented) the library will take the
defaults.  NB: The parser is case-sensitive and uses the ":" as the parsing
token.

.SH AUTHOR
Michael T. Peterson <mtp@zso.dec. mtp@big.aa.net>
